Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.joda.time
Class DateTimeField

    java.lang.Object
      org.joda.time.DateTimeField

Direct Known Subclasses:
  BaseDateTimeField, DelegatedDateTimeField, UnsupportedDateTimeField

    public abstract class DateTimeField

extends java.lang.Object

Defines the calculation engine for date and time fields. The interface defines a set of methods that manipulate a millisecond datetime with regards to a single field, such as monthOfYear or secondOfMinute.

This design is extensible so, if you wish, you can extract a different field from the milliseconds. A number of standard implementations are provided to assist.

Since:
  1.0
Author:
  Guy Allard, Stephen Colebourne, Brian S O'Neill

Constructor Summary
`DateTimeField()`

Method Summary
`abstract long` | `add(long instant, int value)` Adds a value (which may be negative) to the millis value, overflowing into larger fields if necessary.
`abstract long` | `add(long instant, long value)` Adds a value (which may be negative) to the millis value, overflowing into larger fields if necessary.
`abstract int[]` | `add(ReadablePartial instant, int fieldIndex, int[] values, int valueToAdd)` Adds a value (which may be negative) to the partial instant, throwing an exception if the maximum size of the instant is reached.
`abstract long` | `addWrapField(long instant, int value)` Adds a value (which may be negative) to the millis value, wrapping within this field.
`abstract int[]` | `addWrapField(ReadablePartial instant, int fieldIndex, int[] values, int valueToAdd)` Adds a value (which may be negative) to the partial instant, wrapping within this field.
`abstract int[]` | `addWrapPartial(ReadablePartial instant, int fieldIndex, int[] values, int valueToAdd)` Adds a value (which may be negative) to the partial instant, wrapping the whole partial if the maximum size of the partial is reached.
`abstract int` | `get(long instant)` Get the value of this field from the milliseconds.
`abstract java.lang.String` | `getAsShortText(int fieldValue, java.util.Locale locale)` Get the human-readable, short text value of this field from the field value.
`abstract java.lang.String` | `getAsShortText(long instant)` Get the human-readable, short text value of this field from the milliseconds.
`abstract java.lang.String` | `getAsShortText(long instant, java.util.Locale locale)` Get the human-readable, short text value of this field from the milliseconds.
`abstract java.lang.String` | `getAsShortText(ReadablePartial partial, int fieldValue, java.util.Locale locale)` Get the human-readable, short text value of this field from a partial instant.
`abstract java.lang.String` | `getAsShortText(ReadablePartial partial, java.util.Locale locale)` Get the human-readable, short text value of this field from a partial instant.
`abstract java.lang.String` | `getAsText(int fieldValue, java.util.Locale locale)` Get the human-readable, text value of this field from the field value.
`abstract java.lang.String` | `getAsText(long instant)` Get the human-readable, text value of this field from the milliseconds.
`abstract java.lang.String` | `getAsText(long instant, java.util.Locale locale)` Get the human-readable, text value of this field from the milliseconds.
`abstract java.lang.String` | `getAsText(ReadablePartial partial, int fieldValue, java.util.Locale locale)` Get the human-readable, text value of this field from a partial instant.
`abstract java.lang.String` | `getAsText(ReadablePartial partial, java.util.Locale locale)` Get the human-readable, text value of this field from a partial instant.
`abstract int` | `getDifference(long minuendInstant, long subtrahendInstant)` Computes the difference between two instants, as measured in the units of this field.
`abstract long` | `getDifferenceAsLong(long minuendInstant, long subtrahendInstant)` Computes the difference between two instants, as measured in the units of this field.
`abstract DurationField` | `getDurationField()` Returns the duration per unit value of this field.
`abstract int` | `getLeapAmount(long instant)` Gets the amount by which this field is 'leap' for the specified instant.
`abstract DurationField` | `getLeapDurationField()` If this field were to leap, then it would be in units described by the returned duration.
`abstract int` | `getMaximumShortTextLength(java.util.Locale locale)` Get the maximum short text value for this field.
`abstract int` | `getMaximumTextLength(java.util.Locale locale)` Get the maximum text value for this field.
`abstract int` | `getMaximumValue()` Get the maximum allowable value for this field.
`abstract int` | `getMaximumValue(long instant)` Get the maximum value for this field evaluated at the specified time.
`abstract int` | `getMaximumValue(ReadablePartial instant)` Get the maximum value for this field evaluated at the specified time.
`abstract int` | `getMaximumValue(ReadablePartial instant, int[] values)` Get the maximum value for this field using the partial instant and the specified values.
`abstract int` | `getMinimumValue()` Get the minimum allowable value for this field.
`abstract int` | `getMinimumValue(long instant)` Get the minimum value for this field evaluated at the specified time.
`abstract int` | `getMinimumValue(ReadablePartial instant)` Get the minimum value for this field evaluated at the specified time.
`abstract int` | `getMinimumValue(ReadablePartial instant, int[] values)` Get the minimum value for this field using the partial instant and the specified values.
`abstract java.lang.String` | `getName()` Get the name of the field.
`abstract DurationField` | `getRangeDurationField()` Returns the range duration of this field.
`abstract DateTimeFieldType` | `getType()` Get the type of the field.
`abstract boolean` | `isLeap(long instant)` Returns whether this field is 'leap' for the specified instant.
`abstract boolean` | `isLenient()` Returns true if the set method is lenient.
`abstract boolean` | `isSupported()` Returns true if this field is supported.
`abstract long` | `remainder(long instant)` Returns the fractional duration milliseconds of this field.
`abstract long` | `roundCeiling(long instant)` Round to the highest whole unit of this field.
`abstract long` | `roundFloor(long instant)` Round to the lowest whole unit of this field.
`abstract long` | `roundHalfCeiling(long instant)` Round to the nearest whole unit of this field.
`abstract long` | `roundHalfEven(long instant)` Round to the nearest whole unit of this field.
`abstract long` | `roundHalfFloor(long instant)` Round to the nearest whole unit of this field.
`abstract long` | `set(long instant, int value)` Sets a value in the milliseconds supplied.
`abstract long` | `set(long instant, java.lang.String text)` Sets a value in the milliseconds supplied from a human-readable, text value.
`abstract long` | `set(long instant, java.lang.String text, java.util.Locale locale)` Sets a value in the milliseconds supplied from a human-readable, text value.
`abstract int[]` | `set(ReadablePartial instant, int fieldIndex, int[] values, int newValue)` Sets a value using the specified partial instant.
`abstract int[]` | `set(ReadablePartial instant, int fieldIndex, int[] values, java.lang.String text, java.util.Locale locale)` Sets a value in the milliseconds supplied from a human-readable, text value.
`abstract java.lang.String` | `toString()` Get a suitable debug string.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### DateTimeField

    public DateTimeField()

Method Detail

### getType

    public abstract DateTimeFieldType getType()

  Get the type of the field.

  Returns:
    field type

### getName

    public abstract java.lang.String getName()

  Get the name of the field.

  By convention, names follow a pattern of "dddOfRrr", where "ddd" represents the (singular) duration unit field name and "Rrr" represents the (singular) duration range field name. If the range field is not applicable, then the name of the field is simply the (singular) duration field name.

  Returns:
    field name

### isSupported

    public abstract boolean isSupported()

  Returns true if this field is supported.

  Returns:
    true if this field is supported

### isLenient

    public abstract boolean isLenient()

  Returns true if the set method is lenient. If so, it accepts values that are out of bounds. For example, a lenient day of month field accepts 32 for January, converting it to February 1.

  Returns:
    true if this field is lenient

### get

    public abstract int get(long instant)

  Get the value of this field from the milliseconds.

  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to query
  Returns:
    the value of the field, in the units of the field

### getAsText

    public abstract java.lang.String getAsText(long instant,
                                               java.util.Locale locale)

  Get the human-readable, text value of this field from the milliseconds. If the specified locale is null, the default locale is used.

  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to query
    `locale` - the locale to use for selecting a text symbol, null for default
  Returns:
    the text value of the field

### getAsText

    public abstract java.lang.String getAsText(long instant)

  Get the human-readable, text value of this field from the milliseconds.

  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to query
  Returns:
    the text value of the field

### getAsText

    public abstract java.lang.String getAsText(ReadablePartial partial,
                                               int fieldValue,
                                               java.util.Locale locale)

  Get the human-readable, text value of this field from a partial instant. If the specified locale is null, the default locale is used.

  Parameters:
    `partial` - the partial instant to query
    `fieldValue` - the field value of this field, provided for performance
    `locale` - the locale to use for selecting a text symbol, null for default
  Returns:
    the text value of the field

### getAsText

    public abstract java.lang.String getAsText(ReadablePartial partial,
                                               java.util.Locale locale)

  Get the human-readable, text value of this field from a partial instant. If the specified locale is null, the default locale is used.

  Parameters:
    `partial` - the partial instant to query
    `locale` - the locale to use for selecting a text symbol, null for default
  Returns:
    the text value of the field

### getAsText

    public abstract java.lang.String getAsText(int fieldValue,
                                               java.util.Locale locale)

  Get the human-readable, text value of this field from the field value. If the specified locale is null, the default locale is used.

  Parameters:
    `fieldValue` - the numeric value to convert to text
    `locale` - the locale to use for selecting a text symbol, null for default
  Returns:
    the text value of the field

### getAsShortText

    public abstract java.lang.String getAsShortText(long instant,
                                                    java.util.Locale locale)

  Get the human-readable, short text value of this field from the milliseconds. If the specified locale is null, the default locale is used.

  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to query
    `locale` - the locale to use for selecting a text symbol, null for default
  Returns:
    the short text value of the field

### getAsShortText

    public abstract java.lang.String getAsShortText(long instant)

  Get the human-readable, short text value of this field from the milliseconds.

  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to query
  Returns:
    the short text value of the field

### getAsShortText

    public abstract java.lang.String getAsShortText(ReadablePartial partial,
                                                    int fieldValue,
                                                    java.util.Locale locale)

  Get the human-readable, short text value of this field from a partial instant. If the specified locale is null, the default locale is used.

  Parameters:
    `partial` - the partial instant to query
    `fieldValue` - the field value of this field, provided for performance
    `locale` - the locale to use for selecting a text symbol, null for default
  Returns:
    the text value of the field

### getAsShortText

    public abstract java.lang.String getAsShortText(ReadablePartial partial,
                                                    java.util.Locale locale)

  Get the human-readable, short text value of this field from a partial instant. If the specified locale is null, the default locale is used.

  Parameters:
    `partial` - the partial instant to query
    `locale` - the locale to use for selecting a text symbol, null for default
  Returns:
    the text value of the field

### getAsShortText

    public abstract java.lang.String getAsShortText(int fieldValue,
                                                    java.util.Locale locale)

  Get the human-readable, short text value of this field from the field value. If the specified locale is null, the default locale is used.

  Parameters:
    `fieldValue` - the numeric value to convert to text
    `locale` - the locale to use for selecting a text symbol, null for default
  Returns:
    the text value of the field

### add

    public abstract long add(long instant,
                             int value)

  Adds a value (which may be negative) to the millis value, overflowing into larger fields if necessary.

  The value will be added to this field. If the value is too large to be added solely to this field, larger fields will increase as required. Smaller fields should be unaffected, except where the result would be an invalid value for a smaller field. In this case the smaller field is adjusted to be in range.

  For example, in the ISO chronology:
  2000-08-20 add six months is 2001-02-20
  2000-08-20 add twenty months is 2002-04-20
  2000-08-20 add minus nine months is 1999-11-20
  2001-01-31 add one month is 2001-02-28
  2001-01-31 add two months is 2001-03-31

  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to add to
    `value` - the value to add, in the units of the field
  Returns:
    the updated milliseconds

### add

    public abstract long add(long instant,
                             long value)

  Adds a value (which may be negative) to the millis value, overflowing into larger fields if necessary.

  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to add to
    `value` - the long value to add, in the units of the field
  Returns:
    the updated milliseconds
  Throws:
    `java.lang.IllegalArgumentException` - if value is too large
  See Also:
    `add(long,int)`

### add

    public abstract int[] add(ReadablePartial instant,
                              int fieldIndex,
                              int[] values,
                              int valueToAdd)

  Adds a value (which may be negative) to the partial instant, throwing an exception if the maximum size of the instant is reached.

  The value will be added to this field, overflowing into larger fields if necessary. Smaller fields should be unaffected, except where the result would be an invalid value for a smaller field. In this case the smaller field is adjusted to be in range.

  Partial instants only contain some fields. This may result in a maximum possible value, such as TimeOfDay being limited to 23:59:59:999. If this limit is breached by the add an exception is thrown.

  For example, in the ISO chronology:
  2000-08-20 add six months is 2000-02-20
  2000-08-20 add twenty months is 2000-04-20
  2000-08-20 add minus nine months is 2000-11-20
  2001-01-31 add one month is 2001-02-28
  2001-01-31 add two months is 2001-03-31

  Parameters:
    `instant` - the partial instant
    `fieldIndex` - the index of this field in the instant
    `values` - the values of the partial instant which should be updated
    `valueToAdd` - the value to add, in the units of the field
  Returns:
    the passed in values
  Throws:
    `java.lang.IllegalArgumentException` - if the value is invalid or the maximum instant is reached

### addWrapPartial

    public abstract int[] addWrapPartial(ReadablePartial instant,
                                         int fieldIndex,
                                         int[] values,
                                         int valueToAdd)

  Adds a value (which may be negative) to the partial instant, wrapping the whole partial if the maximum size of the partial is reached.

  The value will be added to this field, overflowing into larger fields if necessary. Smaller fields should be unaffected, except where the result would be an invalid value for a smaller field. In this case the smaller field is adjusted to be in range.

  Partial instants only contain some fields. This may result in a maximum possible value, such as TimeOfDay normally being limited to 23:59:59:999. If ths limit is reached by the addition, this method will wrap back to 00:00:00.000. In fact, you would generally only use this method for classes that have a limitation such as this.

  For example, in the ISO chronology:
  10:20:30 add 20 minutes is 10:40:30
  10:20:30 add 45 minutes is 11:05:30
  10:20:30 add 16 hours is 02:20:30

  Parameters:
    `instant` - the partial instant
    `fieldIndex` - the index of this field in the partial
    `values` - the values of the partial instant which should be updated
    `valueToAdd` - the value to add, in the units of the field
  Returns:
    the passed in values
  Throws:
    `java.lang.IllegalArgumentException` - if the value is invalid or the maximum instant is reached

### addWrapField

    public abstract long addWrapField(long instant,
                                      int value)

  Adds a value (which may be negative) to the millis value, wrapping within this field.

  The value will be added to this field. If the value is too large to be added solely to this field then it wraps. Larger fields are always unaffected. Smaller fields should be unaffected, except where the result would be an invalid value for a smaller field. In this case the smaller field is adjusted to be in range.

  For example, in the ISO chronology:
  2000-08-20 addWrapField six months is 2000-02-20
  2000-08-20 addWrapField twenty months is 2000-04-20
  2000-08-20 addWrapField minus nine months is 2000-11-20
  2001-01-31 addWrapField one month is 2001-02-28
  2001-01-31 addWrapField two months is 2001-03-31

  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to add to
    `value` - the value to add, in the units of the field
  Returns:
    the updated milliseconds

### addWrapField

    public abstract int[] addWrapField(ReadablePartial instant,
                                       int fieldIndex,
                                       int[] values,
                                       int valueToAdd)

  Adds a value (which may be negative) to the partial instant, wrapping within this field.

  The value will be added to this field. If the value is too large to be added solely to this field then it wraps. Larger fields are always unaffected. Smaller fields should be unaffected, except where the result would be an invalid value for a smaller field. In this case the smaller field is adjusted to be in range.

  For example, in the ISO chronology:
  2000-08-20 addWrapField six months is 2000-02-20
  2000-08-20 addWrapField twenty months is 2000-04-20
  2000-08-20 addWrapField minus nine months is 2000-11-20
  2001-01-31 addWrapField one month is 2001-02-28
  2001-01-31 addWrapField two months is 2001-03-31

  Parameters:
    `instant` - the partial instant
    `fieldIndex` - the index of this field in the instant
    `values` - the values of the partial instant which should be updated
    `valueToAdd` - the value to add, in the units of the field
  Returns:
    the passed in values
  Throws:
    `java.lang.IllegalArgumentException` - if the value is invalid

### getDifference

    public abstract int getDifference(long minuendInstant,
                                      long subtrahendInstant)

  Computes the difference between two instants, as measured in the units of this field. Any fractional units are dropped from the result. Calling getDifference reverses the effect of calling add. In the following code:

       long instant = ...
       int v = ...
       int age = getDifference(add(instant, v), instant);

  The value 'age' is the same as the value 'v'.

  Parameters:
    `minuendInstant` - the milliseconds from 1970-01-01T00:00:00Z to subtract from
    `subtrahendInstant` - the milliseconds from 1970-01-01T00:00:00Z to subtract off the minuend
  Returns:
    the difference in the units of this field

### getDifferenceAsLong

    public abstract long getDifferenceAsLong(long minuendInstant,
                                             long subtrahendInstant)

  Computes the difference between two instants, as measured in the units of this field. Any fractional units are dropped from the result. Calling getDifference reverses the effect of calling add. In the following code:

       long instant = ...
       long v = ...
       long age = getDifferenceAsLong(add(instant, v), instant);

  The value 'age' is the same as the value 'v'.

  Parameters:
    `minuendInstant` - the milliseconds from 1970-01-01T00:00:00Z to subtract from
    `subtrahendInstant` - the milliseconds from 1970-01-01T00:00:00Z to subtract off the minuend
  Returns:
    the difference in the units of this field

### set

    public abstract long set(long instant,
                             int value)

  Sets a value in the milliseconds supplied.

  The value of this field will be set. If the value is invalid, an exception if thrown.

  If setting this field would make other fields invalid, then those fields may be changed. For example if the current date is the 31st January, and the month is set to February, the day would be invalid. Instead, the day would be changed to the closest value - the 28th/29th February as appropriate.

  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to set in
    `value` - the value to set, in the units of the field
  Returns:
    the updated milliseconds
  Throws:
    `java.lang.IllegalArgumentException` - if the value is invalid

### set

    public abstract int[] set(ReadablePartial instant,
                              int fieldIndex,
                              int[] values,
                              int newValue)

  Sets a value using the specified partial instant.

  The value of this field (specified by the index) will be set. If the value is invalid, an exception if thrown.

  If setting this field would make other fields invalid, then those fields may be changed. For example if the current date is the 31st January, and the month is set to February, the day would be invalid. Instead, the day would be changed to the closest value - the 28th/29th February as appropriate.

  Parameters:
    `instant` - the partial instant
    `fieldIndex` - the index of this field in the instant
    `values` - the values of the partial instant which should be updated
    `newValue` - the value to set, in the units of the field
  Returns:
    the passed in values
  Throws:
    `java.lang.IllegalArgumentException` - if the value is invalid

### set

    public abstract long set(long instant,
                             java.lang.String text,
                             java.util.Locale locale)

  Sets a value in the milliseconds supplied from a human-readable, text value. If the specified locale is null, the default locale is used.

  If setting this field would make other fields invalid, then those fields may be changed. For example if the current date is the 31st January, and the month is set to February, the day would be invalid. Instead, the day would be changed to the closest value - the 28th/29th February as appropriate.

  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to set in
    `text` - the text value to set
    `locale` - the locale to use for selecting a text symbol, null for default
  Returns:
    the updated milliseconds
  Throws:
    `java.lang.IllegalArgumentException` - if the text value is invalid

### set

    public abstract long set(long instant,
                             java.lang.String text)

  Sets a value in the milliseconds supplied from a human-readable, text value.

  If setting this field would make other fields invalid, then those fields may be changed. For example if the current date is the 31st January, and the month is set to February, the day would be invalid. Instead, the day would be changed to the closest value - the 28th/29th February as appropriate.

  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to set in
    `text` - the text value to set
  Returns:
    the updated milliseconds
  Throws:
    `java.lang.IllegalArgumentException` - if the text value is invalid

### set

    public abstract int[] set(ReadablePartial instant,
                              int fieldIndex,
                              int[] values,
                              java.lang.String text,
                              java.util.Locale locale)

  Sets a value in the milliseconds supplied from a human-readable, text value. If the specified locale is null, the default locale is used.

  If setting this field would make other fields invalid, then those fields may be changed. For example if the current date is the 31st January, and the month is set to February, the day would be invalid. Instead, the day would be changed to the closest value - the 28th/29th February as appropriate.

  Parameters:
    `instant` - the partial instant
    `fieldIndex` - the index of this field in the instant
    `values` - the values of the partial instant which should be updated
    `text` - the text value to set
    `locale` - the locale to use for selecting a text symbol, null for default
  Returns:
    the passed in values
  Throws:
    `java.lang.IllegalArgumentException` - if the text value is invalid

### getDurationField

    public abstract DurationField getDurationField()

  Returns the duration per unit value of this field. For example, if this field represents "hour of day", then the duration is an hour.

  Returns:
    the duration of this field, or UnsupportedDurationField if field has no duration

### getRangeDurationField

    public abstract DurationField getRangeDurationField()

  Returns the range duration of this field. For example, if this field represents "hour of day", then the range duration is a day.

  Returns:
    the range duration of this field, or null if field has no range

### isLeap

    public abstract boolean isLeap(long instant)

  Returns whether this field is 'leap' for the specified instant.

  For example, a leap year would return true, a non leap year would return false.

  Parameters:
    `instant` - the instant to check for leap status
  Returns:
    true if the field is 'leap'

### getLeapAmount

    public abstract int getLeapAmount(long instant)

  Gets the amount by which this field is 'leap' for the specified instant.

  For example, a leap year would return one, a non leap year would return zero.

  Parameters:
    `instant` - the instant to check for leap status
  Returns:
    the amount, in units of the leap duration field, that the field is leap

### getLeapDurationField

    public abstract DurationField getLeapDurationField()

  If this field were to leap, then it would be in units described by the returned duration. If this field doesn't ever leap, null is returned.

  Returns:
    the leap duration field if field can be leap, null if it can't

### getMinimumValue

    public abstract int getMinimumValue()

  Get the minimum allowable value for this field.

  Returns:
    the minimum valid value for this field, in the units of the field

### getMinimumValue

    public abstract int getMinimumValue(long instant)

  Get the minimum value for this field evaluated at the specified time.

  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to query
  Returns:
    the minimum value for this field, in the units of the field

### getMinimumValue

    public abstract int getMinimumValue(ReadablePartial instant)

  Get the minimum value for this field evaluated at the specified time.

  Parameters:
    `instant` - the partial instant to query
  Returns:
    the minimum value for this field, in the units of the field

### getMinimumValue

    public abstract int getMinimumValue(ReadablePartial instant,
                                        int[] values)

  Get the minimum value for this field using the partial instant and the specified values.

  Parameters:
    `instant` - the partial instant to query
    `values` - the values to use
  Returns:
    the minimum value for this field, in the units of the field

### getMaximumValue

    public abstract int getMaximumValue()

  Get the maximum allowable value for this field.

  Returns:
    the maximum valid value for this field, in the units of the field

### getMaximumValue

    public abstract int getMaximumValue(long instant)

  Get the maximum value for this field evaluated at the specified time.

  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to query
  Returns:
    the maximum value for this field, in the units of the field

### getMaximumValue

    public abstract int getMaximumValue(ReadablePartial instant)

  Get the maximum value for this field evaluated at the specified time.

  Parameters:
    `instant` - the partial instant to query
  Returns:
    the maximum value for this field, in the units of the field

### getMaximumValue

    public abstract int getMaximumValue(ReadablePartial instant,
                                        int[] values)

  Get the maximum value for this field using the partial instant and the specified values.

  Parameters:
    `instant` - the partial instant to query
    `values` - the values to use
  Returns:
    the maximum value for this field, in the units of the field

### getMaximumTextLength

    public abstract int getMaximumTextLength(java.util.Locale locale)

  Get the maximum text value for this field.

  Parameters:
    `locale` - the locale to use for selecting a text symbol
  Returns:
    the maximum text length

### getMaximumShortTextLength

    public abstract int getMaximumShortTextLength(java.util.Locale locale)

  Get the maximum short text value for this field.

  Parameters:
    `locale` - the locale to use for selecting a text symbol
  Returns:
    the maximum short text length

### roundFloor

    public abstract long roundFloor(long instant)

  Round to the lowest whole unit of this field. After rounding, the value of this field and all fields of a higher magnitude are retained. The fractional millis that cannot be expressed in whole increments of this field are set to minimum.

  For example, a datetime of 2002-11-02T23:34:56.789, rounded to the lowest whole hour is 2002-11-02T23:00:00.000.

  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to round
  Returns:
    rounded milliseconds

### roundCeiling

    public abstract long roundCeiling(long instant)

  Round to the highest whole unit of this field. The value of this field and all fields of a higher magnitude may be incremented in order to achieve this result. The fractional millis that cannot be expressed in whole increments of this field are set to minimum.

  For example, a datetime of 2002-11-02T23:34:56.789, rounded to the highest whole hour is 2002-11-03T00:00:00.000.

  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to round
  Returns:
    rounded milliseconds

### roundHalfFloor

    public abstract long roundHalfFloor(long instant)

  Round to the nearest whole unit of this field. If the given millisecond value is closer to the floor or is exactly halfway, this function behaves like roundFloor. If the millisecond value is closer to the ceiling, this function behaves like roundCeiling.

  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to round
  Returns:
    rounded milliseconds

### roundHalfCeiling

    public abstract long roundHalfCeiling(long instant)

  Round to the nearest whole unit of this field. If the given millisecond value is closer to the floor, this function behaves like roundFloor. If the millisecond value is closer to the ceiling or is exactly halfway, this function behaves like roundCeiling.

  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to round
  Returns:
    rounded milliseconds

### roundHalfEven

    public abstract long roundHalfEven(long instant)

  Round to the nearest whole unit of this field. If the given millisecond value is closer to the floor, this function behaves like roundFloor. If the millisecond value is closer to the ceiling, this function behaves like roundCeiling.

  If the millisecond value is exactly halfway between the floor and ceiling, the ceiling is chosen over the floor only if it makes this field's value even.

  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to round
  Returns:
    rounded milliseconds

### remainder

    public abstract long remainder(long instant)

  Returns the fractional duration milliseconds of this field. In other words, calling remainder returns the duration that roundFloor would subtract.

  For example, on a datetime of 2002-11-02T23:34:56.789, the remainder by hour is 34 minutes and 56.789 seconds.

  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to get the remainder
  Returns:
    remainder duration, in milliseconds

### toString

    public abstract java.lang.String toString()

  Get a suitable debug string.

  Overrides:
    `toString` in class `java.lang.Object`
  Returns:
    debug string

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD